function range(start, stop, step)
    if stop == nil then
        stop = start
        start = 1
    end
    step = step or 1
    local i = start - step
    local iterator -- decl.
    iterator = function() -- def.
        i = i + step
        if i <= stop then return i end
    end
    return iterator
end
    
function arraycomp(fn, iter)
    local out = {}
    while true do
        local r = table.pack(iter())
        if r[1] == nil then break end
        table.insert(out, fn(table.unpack(r)))
    end
    return out
end

function arrayconcat(a, b)
    local out = {}
    table.move(a, 1, #a, 1, out)
    table.move(b, 1, #b, #a+1, out)
    return out
end

function zip(a, b)
    local i = 0
    return function()
        i = i + 1
        local aV, bV = a[i], b[i]
        if aV and bV then
            return aV, bV
        end
    end
end

function sum(t)
    local acc = 0
    for _,v in ipairs(t) do
        acc = acc + v
    end
    return acc
end
